Pictogram Population in JavaScript

Using ApexCharts with JavaScript

This Pictogram Population example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// A person icon, drawn inline as a data URI so the sample is self-contained.
var PERSON_ICON =
  'data:image/svg+xml,' +
  encodeURIComponent(
    '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="#5B8DEF">' +
      '<circle cx="12" cy="7" r="4"/>' +
      '<path d="M4 21c0-4.4 3.6-8 8-8s8 3.6 8 8z"/>' +
      '</svg>',
  )

var options = {
  series: [520000, 1180000, 300000],
  chart: {
    type: 'unit',
    height: 440,
    animations: {
      enabled: true,
      speed: 900,
    },
  },
  labels: ['Under 18', '18 to 64', '65 and over'],
  colors: ['#5B8DEF', '#00B8A9', '#F6A609'],
  series: [520000, 1180000, 300000],
  legend: {
    position: 'bottom',
  },
  plotOptions: {
    unit: {
      layout: 'grouped',
      shape: 'image',
      unitValue: 25000,
      spacing: 1.2,
      image: {
        src: PERSON_ICON,
        width: 16,
        height: 16,
        // Recolour each icon to its category colour so the crowd matches the
        // legend (the source icon is a single-colour silhouette).
        tint: true,
      },
      clusterLabels: {
        show: true,
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

// Nothing extra to wire: the chart renders the pictogram from the options
// above. PERSON_ICON lives in the shared head script.

Pictogram Population in React

Using ApexCharts with React

This Pictogram Population example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// A person icon, drawn inline as a data URI so the sample is self-contained.
var PERSON_ICON =
  'data:image/svg+xml,' +
  encodeURIComponent(
    '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="#5B8DEF">' +
      '<circle cx="12" cy="7" r="4"/>' +
      '<path d="M4 21c0-4.4 3.6-8 8-8s8 3.6 8 8z"/>' +
      '</svg>',
  )

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [520000, 1180000, 300000],
    options: {
      chart: {
        type: 'unit',
        height: 440,
        animations: {
          enabled: true,
          speed: 900,
        },
      },
      labels: ['Under 18', '18 to 64', '65 and over'],
      colors: ['#5B8DEF', '#00B8A9', '#F6A609'],
      series: [520000, 1180000, 300000],
      legend: {
        position: 'bottom',
      },
      plotOptions: {
        unit: {
          layout: 'grouped',
          shape: 'image',
          unitValue: 25000,
          spacing: 1.2,
          image: {
            src: PERSON_ICON,
            width: 16,
            height: 16,
            // Recolour each icon to its category colour so the crowd matches the
            // legend (the source icon is a single-colour silhouette).
            tint: true,
          },
          clusterLabels: {
            show: true,
          },
        },
      },
    },
  })

  // Nothing extra to wire: the chart renders the pictogram from the options
  // above. PERSON_ICON lives in the shared head script.

  return (
    <div>
      <div className="wrap">
        <h1>Pictogram (isotype) unit chart</h1>
        <p>A pictogram unit chart: each icon stands for 25,000 people.</p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="unit"
              height={440}
            />
          </div>
        </div>

        <div className="note">1 icon = 25,000 people</div>
      </div>
    </div>
  )
}

export default ApexChart

Pictogram Population in Angular

Using ApexCharts with Angular

This Pictogram Population example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private PERSON_ICON: any = 'data:image/svg+xml,' +
          encodeURIComponent(
            '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="#5B8DEF">' +
              '<circle cx="12" cy="7" r="4"/>' +
              '<path d="M4 21c0-4.4 3.6-8 8-8s8 3.6 8 8z"/>' +
              '</svg>',
          );

  public chartOptions: Partial<ChartOptions> = {
          series: [520000, 1180000, 300000],
          chart: {
            type: 'unit',
            height: 440,
            animations: {
              enabled: true,
              speed: 900,
            },
          },
          labels: ['Under 18', '18 to 64', '65 and over'],
          colors: ['#5B8DEF', '#00B8A9', '#F6A609'],
          series: [520000, 1180000, 300000],
          legend: {
            position: 'bottom',
          },
          plotOptions: {
            unit: {
              layout: 'grouped',
              shape: 'image',
              unitValue: 25000,
              spacing: 1.2,
              image: {
                src: this.PERSON_ICON,
                width: 16,
                height: 16,
                // Recolour each icon to its category colour so the crowd matches the
                // legend (the source icon is a single-colour silhouette).
                tint: true,
              },
              clusterLabels: {
                show: true,
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Pictogram Population in Vue

Using ApexCharts with Vue

This Pictogram Population example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Pictogram (isotype) unit chart</h1>
      <p>A pictogram unit chart: each icon stands for 25,000 people.</p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="unit"
            height="440"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="note">1 icon = 25,000 people</div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// A person icon, drawn inline as a data URI so the sample is self-contained.
var PERSON_ICON =
  'data:image/svg+xml,' +
  encodeURIComponent(
    '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="#5B8DEF">' +
      '<circle cx="12" cy="7" r="4"/>' +
      '<path d="M4 21c0-4.4 3.6-8 8-8s8 3.6 8 8z"/>' +
      '</svg>',
  )

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [520000, 1180000, 300000],
      chartOptions: {
        chart: {
          type: 'unit',
          height: 440,
          animations: {
            enabled: true,
            speed: 900,
          },
        },
        labels: ['Under 18', '18 to 64', '65 and over'],
        colors: ['#5B8DEF', '#00B8A9', '#F6A609'],
        series: [520000, 1180000, 300000],
        legend: {
          position: 'bottom',
        },
        plotOptions: {
          unit: {
            layout: 'grouped',
            shape: 'image',
            unitValue: 25000,
            spacing: 1.2,
            image: {
              src: PERSON_ICON,
              width: 16,
              height: 16,
              // Recolour each icon to its category colour so the crowd matches the
              // legend (the source icon is a single-colour silhouette).
              tint: true,
            },
            clusterLabels: {
              show: true,
            },
          },
        },
      },
    }
  },
  // Nothing extra to wire: the chart renders the pictogram from the options
  // above. PERSON_ICON lives in the shared head script.,
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 720px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
p {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 24px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  color: #8592a0;
  font-size: 12px;
  text-align: center;
  margin-top: 12px;
}
</style>